Unit SF55R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF14_p, SF35R_p;

function SF55R(X :Real; DF :Real; var IERR :Integer): Real;

implementation

function SF55R(X :Real; DF :Real; var IERR :Integer): Real;
var
T,AN,N,Y,B,A,XJ,Z,Q,W :Real;
const
SYS059 :Real = 3.4E38;
SYS029 :Real = 0.70710678118654752440084436210485;
SYS015 :Real = 0.63661977236758134307553505349006;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
{ Result -    SF55R  FORTRANe }
if ( DF < 1.0 ) 
 then goto _8;
IERR := 0;
T := X;
AN := DF;
N := AN;
T := T*T;
Y := T/AN;
B := 1.0+Y;
if ( (AN <> N ) or ( AN >= 20.0) ) and ( T < AN ) or ( AN > 200.0 )
 then goto _4;
if ( (AN < 20.0) ) and ( (T < 4.0) ) 
 then goto _5;
A := 1.0;
Y := AN;
XJ := 0.0;
Z := 0.0;
_1:
if ( A = Z ) 
 then goto _2;
XJ := XJ+2.0;
Z := A;
Y := Y*(XJ-1.0)/(B*XJ);
A := A+Y/(AN+XJ);
goto _1;
_2:
if ( AN <= 1.0 ) 
 then goto _3;
A := (AN-1.0)/(B*AN)*A;
AN := AN-2.0;
goto _2;
_3:
if ( AN <> 0.0 ) 
 then A := Sqrt(B)*SYS015*A/B;
Q := A;
goto _9;
_4:
W := B-1.0;
if ( W <> 0.0 ) 
 then Y := Y*(Ln(B)/W);
A := AN-0.5;
B := 48.0*A*A;
Y := Y*A;
Y := (((((-0.4*Y-3.3)*Y-24.0)*Y-85.5)/(0.8*(Y*Y)+100.0+B)
    +Y+3.0)/B+1.0)*Sqrt(Y);
Q := SF35R(Y*SYS029);
goto _9;
_5:
Y := Sqrt(Y);
A := Y;
if ( AN = 1.0 ) 
 then A := 0.0;
_6:
AN := AN-2.0;
if ( AN <= 1.0 ) 
 then goto _7;
A := (AN-1.0)/(B*AN)*A+Y;
goto _6;
_7:
if ( AN = 0.0 ) 
 then A := A/Sqrt(B);
if ( AN <> 0.0 ) 
 then A := (ArcTan(Y)+A/B)*SYS015;
Q := 1.0-A;
goto _9;
_8:
IERR := 65;
Result := SYS059;
UTSF14(IERR,55);
goto _10;
_9:
Result := Q;
_10:
exit;
end;

end.
